<?php
/*
Plugin Name: WPsite Flyout Fire
plugin URI:
Description: The WPsite Flyout Fire plugin creates notifications to drive traffic to targeted pages, increase newsletter signups by 50%, and make more sales.
version: 2.0.0
Author: WPSITE.NET
Author URI: http://www.wpsite.net
License: GPL2
*/

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

/**
 * Global Definitions
 */

// Item Name

if (!defined('WPSITE_FLYOUT_FIRE_ITEM_NAME'))
    define('WPSITE_FLYOUT_FIRE_ITEM_NAME', 'Flyout Fire - Slide In Panels for WordPress');

// Store URL

if (!defined('WPSITE_FLYOUT_FIRE_STORE_URL'))
    define('WPSITE_FLYOUT_FIRE_STORE_URL', 'https://99robots.com');

// Minimum PHP Version

if (!defined('WPSITE_FLYOUT_FIRE_MIN_PHP_VERSION'))
    define('WPSITE_FLYOUT_FIRE_MIN_PHP_VERSION', '5.4.0');

/* Plugin Name */

if (!defined('WPSITE_FLYOUT_FIRE_PLUGIN_NAME'))
    define('WPSITE_FLYOUT_FIRE_PLUGIN_NAME', trim(dirname(plugin_basename(__FILE__)), '/'));

/* Plugin directory */

if (!defined('WPSITE_FLYOUT_FIRE_PLUGIN_DIR'))
    define('WPSITE_FLYOUT_FIRE_PLUGIN_DIR', WP_PLUGIN_DIR . '/' . WPSITE_FLYOUT_FIRE_PLUGIN_NAME);

/* Plugin url */

if (!defined('WPSITE_FLYOUT_FIRE_PLUGIN_URL'))
    define('WPSITE_FLYOUT_FIRE_PLUGIN_URL', WP_PLUGIN_URL . '/' . WPSITE_FLYOUT_FIRE_PLUGIN_NAME);

/* Plugin verison */

if (!defined('WPSITE_FLYOUT_FIRE_VERSION_NUM'))
    define('WPSITE_FLYOUT_FIRE_VERSION_NUM', '2.0.0');

// Date Format

if (!defined('WPSITE_FLYOUT_FIRE_DATE_FORMAT'))
    define('WPSITE_FLYOUT_FIRE_DATE_FORMAT', 'Y-m-d');

/**
 * Activatation / Deactivation
 */

register_activation_hook( __FILE__, 	array('WPsite_Flyout_Fire', 'register_activation'));


/**
 * Hooks / Filter
 */

add_action('admin_menu', 				array('WPsite_Flyout_Fire','menu'));
add_action('init', 						array('WPsite_Flyout_Fire', 'wpsite_load_textdoamin'));

include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . "/admin/functions.php");
include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . "/core/functions.php");
include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . "/core/model/stats.php");
include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . "/core/model/email-signups.php");
include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . "/core/model/email-entries.php");

// Software Licensing Updates

add_action('wp_ajax_wps_ff_license_action', array('WPsite_Flyout_Fire', 'license_action'));

if ( !class_exists('EDD_SL_Plugin_Updater') ) {
	include_once( dirname( __FILE__ ) . '/admin/includes/edd-software-licensing-updates/EDD_SL_Plugin_Updater.php' );
}

$edd_updater = new EDD_SL_Plugin_Updater( WPSITE_FLYOUT_FIRE_STORE_URL , __FILE__, array(
		'version' 	=> WPSITE_FLYOUT_FIRE_VERSION_NUM,
		'license' 	=> WPsite_Flyout_Fire::get_license_key(),
		'item_name' => WPSITE_FLYOUT_FIRE_ITEM_NAME,
		'author' 	=> '99 Robots',
	)
);

/**
 *
 * Main class used to manage Flyout Fire
 *
 * @since 1.0.0
 */
class WPsite_Flyout_Fire {

	/**
	 * prefix
	 *
	 * (default value: 'wpsite_flyout_fire_')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $prefix = 'wpsite_flyout_fire_';

	/**
	 * prefix_dash
	 *
	 * (default value: 'wps-ff-')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $prefix_dash = 'wps-ff-';

	/**
	 * text_domain
	 *
	 * (default value: 'wpsite-flyout-fire')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $text_domain = 'wpsite-flyout-fire';

	/**
	 * dashboard_page
	 *
	 * (default value: "wpsite-flyout-fire-dashboard")
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $dashboard_page = "wpsite-flyout-fire-dashboard";

	/**
	 * add_new_page
	 *
	 * (default value: "wpsite-flyout-fire-new-add-edit")
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $add_new_page = "wpsite-flyout-fire-new-add-edit";

	/**
	 * stats_page
	 *
	 * (default value: 'wpsite-flyout-fire-stats')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $stats_page = 'wpsite-flyout-fire-stats';

	/**
	 * emails_page
	 *
	 * (default value: 'wpsite-flyout-fire-emails')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $emails_page = 'wpsite-flyout-fire-emails';

	/**
	 * entries_page
	 *
	 * (default value: 'wpsite-flyout-fire-entries')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $entries_page = 'wpsite-flyout-fire-entries';

	/**
	 * updates_page
	 *
	 * (default value: 'wpsite-flyout-fire-updates')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $updates_page = 'wpsite-flyout-fire-updates';

	/**
	 * aweber_app_id
	 *
	 * (default value: 'ee5c6b51')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $aweber_app_id = 'b3bb2d1f';

	/**
	 * effects
	 *
	 * @var mixed
	 * @access public
	 * @static
	 */
	static $effects = array(
		'blind',
		'bounce',
		'clip',
		'drop',
		'explode',
		'fade',
		'fold',
		'highlight',
		'pulsate',
		'scale',
		'shake',
		'size',
		'slide',
	);

	/**
	 * social_icons
	 *
	 * @var mixed
	 * @access public
	 * @static
	 */
	static $social_icons = array(
		'fa-delicious' 		=> 'Delicious',
		'fa-digg' 			=> 'Digg',
		'fa-dribbble' 		=> 'Dribbble',
		'fa-facebook' 		=> 'Facebook',
		'fa-flickr' 		=> 'Flickr',
		'fa-foursquare' 	=> 'Four Square',
		'fa-github' 		=> 'Github',
		'fa-google-plus'	=> 'Google+',
		'fa-linkedin' 		=> 'LinkedIn',
		'fa-instagram'		=> 'Instagram',
		'fa-pinterest' 		=> 'Pinterest',
		'fa-reddit' 		=> 'Reddit',
		'fa-tumblr' 		=> 'Tumblr',
		'fa-twitch' 		=> 'Twitch',
		'fa-twitter' 		=> 'Twitter',
		'fa-vine' 			=> 'Vine',
		'fa-yelp' 			=> 'Yelp',
		'fa-youtube' 		=> 'YouTube',
	);

	/**
	 * font_families
	 *
	 * @var mixed
	 * @access public
	 * @static
	 */
	static $font_families = array(
		'initial',
		'inherit',
		'Georgia, serif',
		'"Palatino Linotype", "Book Antiqua", Palatino, serif',
		'"Times New Roman", Times, serif',
		'Arial, Helvetica, sans-serif',
		'"Arial Black", Gadget, sans-serif',
		'"Comic Sans MS", cursive, sans-serif',
		'Impact, Charcoal, sans-serif',
		'"Lucida Sans Unicode", "Lucida Grande", sans-serif',
		'Tahoma, Geneva, sans-serif',
		'"Trebuchet MS", Helvetica, sans-serif',
		'Verdana, Geneva, sans-serif',
		'"Courier New", Courier, monospace',
		'"Lucida Console", Monaco, monospace',
	);

	/**
	 * Performs tasks needed upon activation
	 *
	 * @since 1.0.0
	 */
	static function register_activation() {

		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . '/admin/activation.php');

	}

	/**
	 * Load the text domain
	 *
	 * @since 1.0.0
	 */
	static function wpsite_load_textdoamin() {
		load_plugin_textdomain(self::$text_domain, false, basename( dirname( __FILE__ ) ) . '/languages' );
	}

	/**
	 * Perform all the actions with a license
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function license_action() {

		if ( !isset($_POST['license_key']) ) {
			echo '';
			die();
		}

		// data to send in our API request

		$api_params = array(
			'edd_action'	=> $_POST['license_action'],
			'license' 		=> $_POST['license_key'],
			'item_name' 	=> urlencode( WPSITE_FLYOUT_FIRE_ITEM_NAME ), // the name of our product in EDD
			'url'       	=> is_multisite() ? network_home_url() : home_url()
		);

		// Call the custom API.

		$response = wp_remote_post( WPSITE_FLYOUT_FIRE_STORE_URL, array( 'timeout' => 15, 'sslverify' => false, 'body' => $api_params ) );

		// make sure the response came back okay

		if ( is_wp_error( $response ) ) {
			echo json_encode($response);
			die();
		}

		$license_data = json_decode( wp_remote_retrieve_body( $response ) );

		if ( $_POST['license_action'] == 'activate_license' ) {
			self::update_license_key($_POST['license_key']);
		} else if ( $_POST['license_action'] == 'deactivate_license' && $license_data->license == 'deactivated') {
			self::update_license_key('');
		}

		// decode the license data

		echo $license_data->license;

		die();

	}

	/**
	 * Check if license key is active
	 *
	 * @access public
	 * @static
	 * @param mixed $license_key
	 * @return void
	 */
	static function is_license_active( $license_key ) {

		if ( !isset( $license_key ) ) {
			return false;
		}

		// data to send in our API request

		$api_params = array(
			'edd_action'	=> 'check_license',
			'license' 		=> $license_key,
			'item_name' 	=> urlencode( WPSITE_FLYOUT_FIRE_ITEM_NAME ), // the name of our product in EDD
			'url'       	=> is_multisite() ? network_home_url() : home_url()
		);

		// Call the custom API.

		$response = wp_remote_post( WPSITE_FLYOUT_FIRE_STORE_URL, array( 'timeout' => 15, 'sslverify' => false, 'body' => $api_params ) );

		// make sure the response came back okay

		if ( is_wp_error( $response ) ) {
			return false;
		}

		$license_data = json_decode( wp_remote_retrieve_body( $response ) );

		// decode the license data

		if ( isset($license_data->license) && $license_data->license == 'valid' ) {
			return true;
		} else {
			return false;
		}

	}

	/**
	 * Get the license key
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_license_key() {

		// Get the license key from based on WordPress install

		if ( function_exists('is_multisite') && is_multisite() ) {
			$license_key = get_site_option(self::$prefix . 'license_key');
		} else {
			$license_key = get_option(self::$prefix . 'license_key');
		}

		// Check if license key is set

		if ( $license_key === false ) {
			$license_key = '';
		}

		return $license_key;
	}

	/**
	 * Update the license key
	 *
	 * @access public
	 * @static
	 * @param mixed $license_key
	 * @return void
	 */
	static function update_license_key($license_key) {

		if ( isset( $license_key ) ) {

			// Get the license key from based on WordPress install

			if ( function_exists('is_multisite') && is_multisite() ) {

				update_site_option(self::$prefix . 'license_key', $license_key);

			} else {

				update_option(self::$prefix . 'license_key', $license_key);

			}

		}

	}

	/**
	 * Hooks for the admin menu and submenus
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function menu() {
	 	add_menu_page(
	 		__("Flyout Fire" , self::$text_domain),
	 		__("Flyout Fire" , self::$text_domain),
	 		'manage_options',
	 		self::$dashboard_page,
	 		array('WPsite_Flyout_Fire','dashboard'),
	    	plugin_dir_url(__FILE__) . 'img/logo.png" style="width:20px;padding-top: 6px;');

		$dashboard_page_load = add_submenu_page(
			self::$dashboard_page,
			__("All Flyouts" , self::$text_domain),
			__("All Flyouts" , self::$text_domain),
			'manage_options',
			self::$dashboard_page,
			array('WPsite_Flyout_Fire','dashboard'));
		add_action("admin_print_scripts-$dashboard_page_load", array('WPsite_Flyout_Fire', 'inline_admin_scripts_dashboard'));

		$add_new_page_load = add_submenu_page(
			self::$dashboard_page,
			__("Add New" , self::$text_domain),
			__("Add New" , self::$text_domain),
			'manage_options',
			self::$add_new_page,
			array('WPsite_Flyout_Fire','add_edit'));
		add_action("admin_print_scripts-$add_new_page_load", array('WPsite_Flyout_Fire', 'inline_admin_scripts_add_edit'));

		$stats_page_load = add_submenu_page(
			self::$dashboard_page,
			__("Stats" , self::$text_domain),
			__("Stats" , self::$text_domain),
			'manage_options',
			self::$stats_page,
			array('WPsite_Flyout_Fire','stats'));
		add_action("admin_print_scripts-$stats_page_load", array('WPsite_Flyout_Fire', 'inline_admin_scripts_stats'));

		$emails_page_load = add_submenu_page(
			self::$dashboard_page,
			__("Emails" , self::$text_domain),
			__("Emails" , self::$text_domain),
			'manage_options',
			self::$emails_page,
			array('WPsite_Flyout_Fire','emails'));
		add_action("admin_print_scripts-$emails_page_load", array('WPsite_Flyout_Fire', 'inline_admin_scripts_emails'));

		$entries_page_load = add_submenu_page(
			self::$dashboard_page,
			__("Entries" , self::$text_domain),
			__("Entries" , self::$text_domain),
			'manage_options',
			self::$entries_page,
			array('WPsite_Flyout_Fire','entries'));
		add_action("admin_print_scripts-$entries_page_load", array('WPsite_Flyout_Fire', 'inline_admin_scripts_entries'));

		$updates_page_load = add_submenu_page(
			self::$dashboard_page,
			__("Updates" , self::$text_domain),
			__("Updates" , self::$text_domain),
			'manage_options',
			self::$updates_page,
			array('WPsite_Flyout_Fire','updates'));
		add_action("admin_print_scripts-$updates_page_load", array('WPsite_Flyout_Fire', 'inline_admin_scripts_updates'));
	}

	/**
	 * Hooks to "admin_print_scripts-$page"
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function inline_admin_scripts_dashboard() {

		// Styles

		wp_enqueue_style(self::$prefix . 'settings_css', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/settings.css');
	    wp_enqueue_style(self::$prefix . 'bootstrap_css', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/nnr-bootstrap.min.css');
	    wp_enqueue_style(self::$prefix . 'fontawesome_css', 							WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/fonts/font-awesome.min.css');
	    wp_enqueue_style('wp-color-picker');

	    // Scripts

		wp_enqueue_script(self::$prefix . 'bootstrap_js', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/bootstrap.js', array('jquery'));
	    wp_enqueue_script(self::$prefix . 'dashboard_js', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/dashboard.js', array('wp-color-picker', 'jquery'), false, true);
	}

	/**
	 * Hooks to "admin_print_scripts-$page"
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function inline_admin_scripts_add_edit() {

		// Styles

		wp_enqueue_style(self::$prefix . 'settings_css', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/settings.css');
		wp_enqueue_style(self::$prefix . 'bootstrap_css', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/nnr-bootstrap.min.css');
		wp_enqueue_style(self::$prefix . 'fontawesome_css', 							WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/fonts/font-awesome.min.css');
		wp_enqueue_style(self::$prefix . 'bootstrap_datetimepicker_css', 				WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/bootstrap-datetimepicker.min.css');
		wp_enqueue_style(self::$prefix . 'bootstrap_iconpicker_css', 					WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/bootstrap-iconpicker.min.css');
		wp_enqueue_style(self::$prefix . 'bootstrap_formhelpers_css', 					WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/bootstrap-formhelpers.min.css');
		wp_enqueue_style(self::$prefix . 'selectize_css', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/includes/selectize/css/selectize.bootstrap3.css');
		wp_enqueue_style('wp-color-picker');

	    // Scripts

		wp_enqueue_media();
		wp_enqueue_script(self::$prefix . 'bootstrap_js', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/bootstrap.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_moment_js', 						WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/moment.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_datetimepicker_js', 				WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/bootstrap-datetimepicker.min.js', array('jquery', self::$prefix . 'bootstrap_moment_js'));
		wp_enqueue_script(self::$prefix . 'bootstrap_iconpicker_iconset_js', 			WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/iconset-glyphicon.min.js', array('jquery', self::$prefix . 'bootstrap_js'));
		wp_enqueue_script(self::$prefix . 'bootstrap_iconpicker_iconset_fontawesome_js',WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/iconset-fontawesome-4.2.0.min.js', array('jquery', self::$prefix . 'bootstrap_js'));
		wp_enqueue_script(self::$prefix . 'bootstrap_iconpicker_js', 					WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/bootstrap-iconpicker.js', array('jquery', self::$prefix . 'bootstrap_js', self::$prefix . 'bootstrap_iconpicker_iconset_js'));
		wp_enqueue_script(self::$prefix . 'bootstrap_formhelpers_js', 					WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/bootstrap-formhelpers.min.js', array('jquery'));
	    wp_enqueue_script(self::$prefix . 'add_edit_js', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/add-edit.js', array('wp-color-picker', 'jquery'), false, true);
	    wp_enqueue_script(self::$prefix . 'selectize_js', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/includes/selectize/js/standalone/selectize.min.js', array('jquery'));
	    wp_enqueue_script(self::$prefix . 'repeater_js', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/repeater.js', array('jquery', 'jquery-ui-sortable'));
	    wp_localize_script(self::$prefix . 'repeater_js', 'wps_ff_repeater_data', array(
			'prefix_dash' 		=> self::$prefix_dash,
			'social_icons'		=> self::$social_icons,
			'remove'			=> __('Remove', self::$text_domain),
			'img_source'		=> WPSITE_FLYOUT_FIRE_PLUGIN_URL  . '/img/icon-drag.png',
		));
	}

	/**
	 * Hooks to "admin_print_scripts-$page"
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function inline_admin_scripts_stats() {

		// Styles

		wp_enqueue_style(self::$prefix . 'settings_css', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/settings.css');
	    wp_enqueue_style(self::$prefix . 'fontawesome_css',								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/fonts/font-awesome.min.css');
	    wp_enqueue_style(self::$prefix . 'bootstrap_css', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/nnr-bootstrap.min.css');
	    wp_enqueue_style(self::$prefix . 'bootstrap_datetimepicker_css', 				WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/bootstrap-datetimepicker.min.css');

	    // Scripts

	    wp_enqueue_script(self::$prefix . 'line_graph_js', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/Chart.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_js',								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/bootstrap.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_moment_js', 						WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/moment.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_datetimepicker_js', 				WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/bootstrap-datetimepicker.min.js', array('jquery', self::$prefix . 'bootstrap_moment_js'));
		wp_enqueue_script(self::$prefix . 'stats_js', 									WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/stats.js', array('jquery'));
		wp_localize_script(self::$prefix . 'stats_js', 'wps_ff_stats_data', array(
			'prefix_dash' 		=> self::$prefix_dash,
			'today'				=> date('m/d/Y')
		));
	}

	/**
	 * Hooks to "admin_print_scripts-$page"
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function inline_admin_scripts_emails() {

		// Styles

		wp_enqueue_style(self::$prefix . 'settings_css', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/settings.css');
	    wp_enqueue_style(self::$prefix . 'fontawesome_css', 							WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/fonts/font-awesome.min.css');
	    wp_enqueue_style(self::$prefix . 'bootstrap_css', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/nnr-bootstrap.min.css');
	    wp_enqueue_style(self::$prefix . 'bootstrap_datetimepicker_css', 				WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/bootstrap-datetimepicker.min.css');

	    // Scripts

		wp_enqueue_script(self::$prefix . 'line_graph_js', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/Chart.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_js', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/bootstrap.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_moment_js', 						WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/moment.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_datetimepicker_js', 				WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/bootstrap-datetimepicker.min.js', array('jquery', self::$prefix . 'bootstrap_moment_js'));
	    wp_enqueue_script(self::$prefix . 'email_js', 									WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/email.js', array('jquery'));
	    wp_localize_script(self::$prefix . 'email_js', 'wps_ff_emails_data', array(
			'prefix_dash' 		=> self::$prefix_dash,
			'today'				=> date('m/d/Y')
		));
	}

	/**
	 * Hooks to "admin_print_scripts-$page"
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function inline_admin_scripts_entries() {

		// Styles

		wp_enqueue_style(self::$prefix . 'settings_css', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/settings.css');
	    wp_enqueue_style(self::$prefix . 'fontawesome_css', 							WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/fonts/font-awesome.min.css');
	    wp_enqueue_style(self::$prefix . 'bootstrap_css', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/nnr-bootstrap.min.css');
	    wp_enqueue_style(self::$prefix . 'bootstrap_datetimepicker_css', 				WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/bootstrap-datetimepicker.min.css');

	    // Scripts

		wp_enqueue_script(self::$prefix . 'line_graph_js', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/Chart.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_js', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/bootstrap.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_moment_js', 						WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/moment.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_datetimepicker_js', 				WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/bootstrap-datetimepicker.min.js', array('jquery', self::$prefix . 'bootstrap_moment_js'));
	    wp_enqueue_script(self::$prefix . 'entries_js', 								WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/entries.js', array('jquery'));
	    wp_localize_script(self::$prefix . 'entries_js', 'wps_ff_entries_data', array(
			'prefix_dash' 		=> self::$prefix_dash,
			'today'				=> date('m/d/Y')
		));
	}

	/**
	 * Hooks to "admin_print_scripts-$page"
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function inline_admin_scripts_updates() {

		wp_enqueue_style(self::$prefix . 'settings_css', 					WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/settings.css');
	    wp_enqueue_style(self::$prefix . 'fontawesome_css', 				WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/fonts/font-awesome.min.css');
	    wp_enqueue_style(self::$prefix . 'bootstrap_css', 					WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/css/nnr-bootstrap.min.css');

	    wp_enqueue_script(self::$prefix . 'updates_js', 					WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/admin/js/updates.js', array('jquery'));
	    wp_localize_script(self::$prefix . 'updates_js', 'wps_ff_updates_data', array(
			'prefix_dash' 		=> self::$prefix_dash,
			'activate_text'		=> __('Activate', self::$text_domain),
			'deactivate_text'	=> __('Deactivate', self::$text_domain),
			'no_license_key'		=> __('Please add or activate your License Key to get automatic updates.  Without a valid license key you will not receive regular updates. You can find your license key', self::$text_domain) . ' <a href="https://99robots.com/dashboard" target="_blank">here</a>',
			'expired'				=> __('EXPIRED: This license key has expired.  Please renew your license key', self::$text_domain) . ' <a href="https://99robots.com/dashboard" target="_blank">here</a>',
			'activation_error'		=> __('INVALID LICENSE KEY: The license key is not valid please try again. You can find your license key', self::$text_domain) . ' <a href="https://99robots.com/dashboard" target="_blank">here</a>.',
			'activation_valid'		=> __('SUCCESS: Your license key is valid.', self::$text_domain),
			'deactivation_valid'	=> __('SUCCESS: This site has been deactivated.', self::$text_domain),
			'deactivation_error'	=> __('DEACTIVATION FAILED: This site could not be deactivated.', self::$text_domain),
		));
	}

	/**
	 * Function called when user loads All Flyout_Fire submenu
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function dashboard() {

		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . "/admin/controllers/dashboard.php");

	}

	/**
	 * Function called when user loads New Flyout submenu
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function add_edit() {

		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . "/admin/controllers/add-edit.php");

	}

	/**
	 * Displays content for the Stats page
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function stats() {

		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . "/admin/controllers/stats.php");

	}

	/**
	 * Dsiplay the Content of the Emails page
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function emails() {

		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . "/admin/controllers/emails.php");

	}

	/**
	 * Dsiplays the content for the Entries page
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function entries() {

		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . "/admin/controllers/entries.php");

	}

	/**
	 * Displays the content for the Updates page
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function updates() {

		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . "/admin/controllers/updates.php");

	}
}
?>